#push功能的代理选择是否为异步推送
class PushSyncClient

  def initialize(opts={})
    opts = HashWithIndifferentAccess.new(opts)
    @sync_push = opts[:sync_push]
    @opts = opts
  end

  def do_push
    push_sync?
  end

  def push_sync?
    if @sync_push
      timeout_seconds = $redis.get('push_timeout').to_i
      if timeout_seconds > 0
        Timeout.timeout(timeout_seconds) {
          ::PushWorker.new.perform(@opts)
        }
      else
        ::PushWorker.new.perform(@opts)
      end
    else
      ::PushWorker.perform_async(@opts)
    end
  end

end